﻿ -----####HPetBattleAny1.62####
----1.5:修改数据传递的方法。
----1.6:换一个记录宠物数量的方式(避免在某些人宠物数量异常时会照成各种不知名的错误)
----1.61:修复自定义名字错误的显示在野外宠物身上的BUG
----1.62:修复一个很大的失误，成长值显示全部多了一个级别。
local _
--- Globals
local _G = getfenv(0)
local hooksecurefunc, tinsert, pairs, wipe = _G.hooksecurefunc, _G.table.insert, _G.pairs, _G.wipe
local ipairs = _G.ipairs
local C_PetJournal = _G.C_PetJournal
--- --------
local VERSION = "v1.34"
local H_PET_BATTLE_CHAT_FRAME={}
local LEVEL_COLLECTED = "(lv:%s)"
local L = HPetLocals


HPetBattleAny = CreateFrame("frame");
HPetBattleAny:SetScript('OnEvent', function(_, event, ...) return HPetBattleAny[event](HPetBattleAny, event, ...) end)

function HPetBattleAny:LoadSomeAny()
	if GetLocale()=="zhCN" then
		PET_BATTLE_COMBAT_LOG_AURA_APPLIED ="%1$s对%3$s %4$s 造成了%2$s效果."
		PET_BATTLE_COMBAT_LOG_PAD_AURA_APPLIED = "%1$s对%3$s 造成了%2$s效果."
	end
	FRAMELOCK_STATES["PETBATTLES"]["Recount_MainWindow"]="hidden"
	FRAMELOCK_STATES["PETBATTLES"]["MinimapCluster"]=""
end

function HPetBattleAny:PlaySoundFile()
------- 这里可以修改声音文件
	PlaySoundFile( [[Sound\Events\scourge_horn.wav]], "Master" );
end
function HPetBattleAny:Loadinginfo()
	self:PetPrintEX(format("HPetBattleAny"..VERSION..L["Loading"],"|cffff0000/hpq|r"))
end
--------------------		SAVE
HPetSaves = {}
function HPetBattleAny:GetDefault()
	return {
		ShowMsg = true,				--在聊天窗口显示信息
		Sound=true,
		ShowGrowInfo=true,			--显示成长值
		PetGreedInfo=false,			--显示品值
		PetBreedInfo=false,			--breeid
		ShowBreedId=false,			--显示breedID
		EnemyAbility=true,			--显示敌对技能
		EnemyAbPoint={},			--位置(nil)
		EnemyAbScale=0.8,			--敌对技能大小
		OnlyInPetInfo=false,
		HighGlow=true,				--战斗中用品质颜色对宠物头像着色
	}
end

HPetSaves = HPetBattleAny:GetDefault()

--------------------		载入宠物手册的数据
HPetBattleAny.HasPet={}

--[[		function	]]--
-----	测试函数
function printt(str)
	if HPetSaves.god then
		print(str)
	end
end

function HPetBattleAny.sortRarityLevelAsc(a, b)
	if a.rarity == b.rarity then
		return a.level < b.level
	else
		return a.rarity < b.rarity
	end
end
-----	却确定宠物信息窗口
function HPetBattleAny:GetPetBattleChatFrmae()
	wipe(H_PET_BATTLE_CHAT_FRAME)
	H_PET_BATTLE_CHAT_FRAME={}
	if HPetSaves.OnlyInPetInfo then
		for _, chatFrameName in pairs(CHAT_FRAMES) do
			local frame = _G[chatFrameName];
			for index = #frame.messageTypeList,1,-1 do
				if frame.messageTypeList[index] == "PET_BATTLE_COMBAT_LOG" then
					table.insert(H_PET_BATTLE_CHAT_FRAME,frame)
					break
				end
			end
		end
	end
	if #H_PET_BATTLE_CHAT_FRAME==0 then
		table.insert(H_PET_BATTLE_CHAT_FRAME,DEFAULT_CHAT_FRAME)
	end
end
-----	打印函数
function HPetBattleAny:PetPrintEX(str,...)
	HPetBattleAny:GetPetBattleChatFrmae()

	for _,frame in pairs(H_PET_BATTLE_CHAT_FRAME) do
		if not frame:IsShown() then FCF_StartAlertFlash(frame) end
		frame:AddMessage(str,...)
	end

end
-----	创建宠物链接
function HPetBattleAny.CreateLinkByInfo(petid,petstate,usecustom)
	if petid == 0 then return nil end
	local name,speciesID,customName
	if not petstate then
		petstate={}
		speciesID, customName, petstate.level = C_PetJournal.GetPetInfoByPetID(petid)
		_, petstate.health, petstate.power, petstate.speed, petstate.rarity = C_PetJournal.GetPetStats(petid)
		if not speciesID then return end
		if not usecustom then customName = nil end
	else	--没有唯一ID说明petid就是唯一ID
		speciesID,petid = petid,0
	end

	name = customName or C_PetJournal.GetPetInfoBySpeciesID(speciesID)
	if name then
		local level,health,power,speed,rarity = petstate.level, petstate.health, petstate.power, petstate.speed, petstate.rarity
		if HPetSaves.god then
			if HPetSaves.god == true then HPetSaves.god = 1 end
			local bhealth,bpower,bspeed,breedId = HPetDate.GetBreedValue(petstate,speciesID,true)
			health=format("%0.f",bhealth*tonumber("1."..(rarity+HPetSaves.god-1))*level*5+100)
			power=format("%0.f",bpower*tonumber("1."..(rarity+HPetSaves.god-1))*level)
			speed=format("%0.f",bspeed*tonumber("1."..(rarity+HPetSaves.god-1))*level)
			rarity=rarity+HPetSaves.god
		end
		local link=""
		rarity = rarity - 1
		link=ITEM_QUALITY_COLORS[rarity].hex.."\124Hbattlepet:"
		link=link..speciesID..":"..level..":"..rarity..":"..health..":"..power..":"..speed..":"..petid
		link=link.."\124h["..(customName or name).."]\124h\124r"
		return link
	end
	return
end

function HPetBattleAny.ShowMaxValue(petstate,speciesID,point)
	if not petstate or petstate.rarity<1 then return end
	local breed = tonumber("1."..((petstate and petstate.rarity-1) or 0))

	-- ghealth,gpower,gspeed	------成长值
	-- thealth,tpower,tspeed	------基础值
	-- bhealth,bpower,bspeed	------breed加值


	local bhealth,bpower,bspeed,breedId,thealth,tpower,tspeed = HPetDate.GetBreedValue(petstate,speciesID)

	local ghealth=format("%.1f",(bhealth+thealth)*5*breed)
	local gpower=format("%.1f",(bpower+tpower)*breed)
	local gspeed=format("%.1f",(bspeed+tspeed)*breed)

	-- 输出值
	local rhealth,rpower,rspeed
	rhealth=""
	rpower=""
	rspeed=""

	if point then
		if HPetSaves.PetBreedInfo then
			rhealth = bhealth
			rpower = bpower
			rspeed = bspeed
		elseif HPetSaves.PetGreedInfo then
			rhealth = bhealth+thealth
			rpower = bpower+tpower
			rspeed = bspeed+tspeed
		else
			rhealth = ghealth
			rpower = gpower
			rspeed = gspeed
		end
	else
		local hpsGetInfo=function()
			if HPetSaves.PetGreedInfo and HPetSaves.PetBreedInfo then
				local ty="+"
				return thealth..ty..bhealth,tpower..ty..bpower,tspeed..ty..bspeed
			elseif HPetSaves.PetBreedInfo then
				return bhealth,bpower,bspeed
			elseif HPetSaves.PetGreedInfo then
				return thealth+bhealth,tpower+bpower,tspeed+bspeed
			end
		end
		local stlye1="(|c"..RAID_CLASS_COLORS["ROGUE"].colorStr.."%s|r)"
		local stlye2="(|c"..RAID_CLASS_COLORS["MAGE"].colorStr.."%s|r)"

		if HPetSaves.PetGreedInfo or HPetSaves.PetBreedInfo  then
			rhealth,rpower,rspeed = hpsGetInfo()
			rhealth = format(stlye2,rhealth)
			rpower 	= format(stlye2,rpower)
			rspeed 	= format(stlye2,rspeed)
		end
		if HPetSaves.ShowGrowInfo then
			rhealth = format(stlye1,ghealth)..rhealth
			rpower = format(stlye1,gpower)..rpower
			rspeed = format(stlye1,gspeed)..rspeed
		end

	end
	return rhealth,rpower,rspeed,breedId
end

-----	调出宠物收集信息(已有宠物信息)
function HPetBattleAny:GetPetCollectedInfo(pets,enemypet,islink)
	local str1=""
	local str2=""
	if enemypet and enemypet.level then
		if enemypet.level>15 then
			enemypet.level = enemypet.level-1
		end
		if enemypet.level>20 then
			enemypet.level = enemypet.level-1
		end
	end
	if pets then
		table.sort(pets,self.sortRarityLevelAsc)
		if enemypet and self.sortRarityLevelAsc(pets[1],enemypet) then
			str1 = str1.."|cffff0000"..L["Only collected"]	.."：|r"
		else
			str1 = str1.."|cffffff00"..COLLECTED.."：|r"
		end
		for i,petInfo in pairs(pets) do
			local petlink
			local _,custname,_,_,_,_,name=C_PetJournal.GetPetInfoByPetID(petInfo.petID)

			if islink then
				petlink=HPetBattleAny.CreateLinkByInfo(petInfo.petID or 0,nil,true)
			end

			if not petlink then
				if custname or name then
					petlink=ITEM_QUALITY_COLORS[petInfo.rarity-1].hex..(custname or name).."|r"
				else
					petlink=ITEM_QUALITY_COLORS[petInfo.rarity-1].hex.._G["BATTLE_PET_BREED_QUALITY"..petInfo.rarity].."|r"

				end
			end


			if petlink then
				if LEVEL_COLLECTED then str2 = format(LEVEL_COLLECTED.."%s",petInfo.level,str2) end
				str2 = petlink..str2
				if not islink then str2="|n"..str2 end
			end
		end
	else
		if C_PetBattles.IsPlayerNPC(2) and select(2,C_PetBattles.IsTrapAvailable())>5 and select(2,C_PetBattles.IsTrapAvailable())<9 then
			str1=str1.."|cffffff00".._G["PET_BATTLE_TRAP_ERR_"..select(2,C_PetBattles.IsTrapAvailable())]
		else
			str1=str1.."|cffff0000"..NOT_COLLECTED.."!|r"
		end
	end
	return str1,str2
end


--[[ 	OnEvent:					PET_BATTLE_OPENING_START	]]--
HPetBattleAny.EnemyPetInfo={}
function HPetBattleAny:PET_BATTLE_OPENING_START()
printt("test:战斗开始")
----- 输出敌对宠物的数据
		local FindBlue=false
		local petOwner=2
		for petIndex=1, C_PetBattles.GetNumPets(petOwner) do

			local speciesID=C_PetBattles.GetPetSpeciesID(petOwner,petIndex)
			local mPet=HPetBattleAny.HasPet[speciesID]
			local level = C_PetBattles.GetLevel(petOwner, petIndex);
			local health = C_PetBattles.GetMaxHealth(petOwner, petIndex);if C_PetBattles.IsPlayerNPC(petOwner) then health =format("%.0f",health * 1.2) end	--生命加20%
			local power = C_PetBattles.GetPower(petOwner, petIndex);
			local speed = C_PetBattles.GetSpeed(petOwner, petIndex);
			local rarity=C_PetBattles.GetBreedQuality(petOwner,petIndex);if rarity>3 then FindBlue=true end;
			local isflying = false
			if C_PetBattles.GetAuraInfo(petOwner,petIndex,1) == 239 then
				speed=format("%.0f",speed/1.5) --速度降50%
				isflying = true
			end

			self.EnemyPetInfo[petIndex]={["level"]=level,["health"]=health,["power"]=power,["speed"]=speed,["rarity"]=rarity,["isflying"]=isflying}

			local breedId=select(4,HPetDate.GetBreedValue(self.EnemyPetInfo[petIndex],speciesID))	--获取breedId

			tmprint=format(L["this is"],petIndex)

			if (breedId and ((breedId>=4 and breedId<=6) or (breedId>=14 and breedId<=16))) then
				tmprint=tmprint..ICON_LIST[ICON_TAG_LIST[strlower(RAID_TARGET_1)]] .. "0|t"
			end

			tmprint=tmprint..HPetBattleAny.CreateLinkByInfo(speciesID,self.EnemyPetInfo[petIndex])

			if LEVEL_COLLECTED then tmprint=format("%s"..LEVEL_COLLECTED,tmprint,level) end

			if HPetSaves.Contrast or true then
				local str1,str2 = HPetBattleAny:GetPetCollectedInfo(mPet,{["level"]=level,["rarity"]=rarity},true)
				tmprint = tmprint..str1..str2
			end

			if HPetSaves.ShowMsg then
				self:PetPrintEX(tmprint)
			end
		end

		if HPetSaves.Sound and FindBlue and C_PetBattles.IsWildBattle() then --C_PetBattles.IsPlayerNPC(2) and select(2,C_PetBattles.IsTrapAvailable())~=7 then
--- 		PlaySoundFile( [[Sound\Event Sounds\Event_wardrum_ogre.wav]], "Master" );
			self:PlaySoundFile()
		end
end


--[[	OnEvent:					PET_JOURNAL_LIST_UPDATE		]]--

function HPetBattleAny:PET_JOURNAL_LIST_UPDATE()
	if (HPetSaves.Contrast or true ) and not self.HasPetloading then
		self:UnregisterEvent("PET_JOURNAL_LIST_UPDATE")
		local _,numPets = C_PetJournal.GetNumPets(false);
		if numPets ~=  self.HasPet.num then
		printt("系统数据:"..numPets.."插件数据"..self.HasPet.num)
			self:LoadUserPetInfo()
		end
		self:RegisterEvent("PET_JOURNAL_LIST_UPDATE")
	end
end
function HPetBattleAny:LoadUserPetInfo()
	printt("test:数据处理.进入判断")
	if HPetBattleAny.HasPetloading then
		return	false
	end
	printt("test:数据处理.开始")
	HPetBattleAny.HasPetloading = true
	wipe(HPetBattleAny.HasPet)
	HPetBattleAny.HasPet.num= 0
	C_PetJournal.ClearSearchFilter();
	C_PetJournal.AddAllPetTypesFilter();
	C_PetJournal.AddAllPetSourcesFilter();
	C_PetJournal.SetFlagFilter(LE_PET_JOURNAL_FLAG_COLLECTED, true)
	C_PetJournal.SetFlagFilter(LE_PET_JOURNAL_FLAG_FAVORITES, false)
	for i=1,select(2,C_PetJournal.GetNumPets(true)) do
		local petID, speciesID, isOwned, _,level= C_PetJournal.GetPetInfoByIndex(i);
		if isOwned then
			if not HPetBattleAny.HasPet[speciesID] then HPetBattleAny.HasPet[speciesID]={} end
			local _,_,_,_,rarity = C_PetJournal.GetPetStats(petID)
--~ 			HPetBattleAny.HasPet.num = HPetBattleAny.HasPet.num + 1
			table.insert(HPetBattleAny.HasPet[speciesID],{petID=petID,rarity=rarity,level=level})
		end
	end
	HPetBattleAny.HasPet.num = select(2,C_PetJournal.GetNumPets(true))
	HPetBattleAny.HasPetloading = false
--~ 	if self.HasPet.num~=select(2,C_PetJournal.GetNumPets(true)) then
--~ 		print("您的宠物数据不正确，您的游戏可能未下载完")
--~ 	end
	printt("test:数据处理.结束,载入数据"..self.HasPet.num)
end


--[[	OnEvent:	 				ADDON_LOADED			]]--
function HPetBattleAny:ADDON_LOADED(_, name)
		if name == "HPetBattleAny" and not self.initialized then
			self:UnregisterEvent("ADDON_LOADED")
			self.initialized = true
			printt("test:插件载入")

			self.hook:init()
			self:initforJournalFrame()
			self:LoadSomeAny()
			self:LoadUserPetInfo()

			self:RegisterEvent("PET_BATTLE_OPENING_START")
			self:RegisterEvent("PET_JOURNAL_LIST_UPDATE")
			self:Loadinginfo()
		end
end



------------------------我是和谐的分割线---------------------------------


function HPetBattleAny:initforJournalFrame()

	button = CreateFrame("Button","HPetInitOpenButton",PetJournal,"UIPanelButtonTemplate")
	button:SetText(L["HPet Options"])
	button:SetHeight(22)
	button:SetWidth(150)
	button:SetPoint("RIGHT", PetJournalFindBattle, "LEFT", -40, 0)
	button:SetScript("OnClick",function()
		if HPetOption then
			if not HPetOption.ready then HPetOption:Init() end
			if not HPetOption:IsShown() then HPetOption:Open() else HPetOption:Hide() end
		end
	end)

	button = CreateFrame("Button","HPetAllInfoButton",PetJournal,"UIMenuButtonStretchTemplate")
	button:SetText(L["Pet All Info"])
	button:SetHeight(20)
	button:SetWidth(100)
	button:SetPoint("TOPRIGHT", PetJournalPetCard, "BOTTOMRIGHT", -5, 0)
	button.rightArrow:Show()
	button:SetScript("OnClick",function()
		if HPetAllInfoFrame then
			if not HPetAllInfoFrame.ready then HPetAllInfoFrame:Init() end
			if not HPetAllInfoFrame:IsShown() then HPetAllInfoFrame:Open() else HPetAllInfoFrame:Hide() end
		end
	end)

 	PetJournalPetCardModelFrame:SetPoint("TOPLEFT",PetJournalPetCard,75,-21)--65
 	PetJournalPetCardShadows:SetPoint("TOPLEFT",PetJournalPetCard,55,-67)--45
end

HPetBattleAny:RegisterEvent("ADDON_LOADED")
